/**
 *  @file Workshop1.m
 *  Workshop1
 *
 *  Created by Andreas Monitzer on 2009-02-18.
 *  Copyright 2009 Andreas Monitzer. All rights reserved.
 */
#import <Foundation/Foundation.h>
#import "Workshop1.h"

@implementation Workshop1
@synthesize quit;

/**
 * @brief Designated initializer. Initializes the file handle for reading.
 *
 * @param fh The file handle
 * @return self
 */
- (id)initWithFileHandle:(NSFileHandle*)fh {
	if((self = [super init])) {
		[[NSNotificationCenter defaultCenter] addObserver:self
												 selector:@selector(read:)
													 name:NSFileHandleReadCompletionNotification
												   object:fh];
		[fh readInBackgroundAndNotify];
		quit = NO;
	}
	return self;
}

/**
 * @brief Reads the new data that has arrived from the file handle.
 *
 * Terminates on EOF or the quit command.
 *
 * @param notification The notfication containing the file handle as the object, and the read data in the userInfo
 */
- (void)read:(NSNotification*)notification {
	NSData *data = [[notification userInfo] objectForKey:NSFileHandleNotificationDataItem];
	
	if([data length] == 0)
		quit = YES;
	else {
		NSString *str = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
		NSLog(@"%@", str);
		NSLog(@"%@", data);
		
		if([str isEqualToString:@"quit\n"])
			quit = YES;
		
		[str release];
		
		[[notification object] readInBackgroundAndNotify];
	}
}

@end
